<template>
  <nav class="navbar navbar-expand navbar-light topbar static-top shadow " :class="`vsm_${props.theme}`">
    <div class="container-fluid">
      <SearchVue/>
      <div class="collapse navbar-collapse justify-content-end" id="navbarSupportedContent">
        <ul class="navbar-nav ml-auto">
          <ThemeButton  @get-dark="getDark($event)"/> 
          <div class="vr"></div>
          <li class="nav-item dropdown no-arrow">
            <div class="  dropdown no-arrow dropstart">
              <a href="#" class="d-flex align-items-center justify-content-center p-3 link-dark text-decoration-none dropdown-toggle" data-bs-toggle="dropdown" aria-expanded="false">
                <img :src="urlImg" alt="mdo" class="rounded-circle" width="35" height="35">
              </a>
              <ul class="dropdown-menu dropdown-menu-dark">
                <li><h6 class="dropdown-header">{{ state.data.displayName }}</h6></li>
                <li><hr class="dropdown-divider"></li>
                <li><a class="dropdown-item"  v-on:click="logoutRedirect" > <font-awesome-icon icon="fa-solid fa-palette" /> Mon Thème</a></li>
                <li><a class="dropdown-item"  v-on:click="logoutRedirect" ><font-awesome-icon icon="fa-solid fa-right-from-bracket"/> Déconnexion</a></li>
              </ul>
            </div>
          </li>
        </ul> 
      </div>    
    </div>
  </nav>
</template>
<script lang="ts" setup>
import ThemeButton from "./ThemesButton.vue";
import SearchVue from "./Search.vue";
import { useMsal } from "../../../composition-api/useMsal";
import { InteractionRequiredAuthError, InteractionStatus } from "@azure/msal-browser";
import { reactive, onMounted, watch ,ref} from 'vue'
import { loginRequest } from "../../../authConfig";
import { callMsGraph, callMsGraphImg } from "../../../utils/MsGraphApiCall";
import UserInfo from "../../../utils/UserInfo";

const { instance, inProgress } = useMsal();
const emit = defineEmits(['get-dark'])
let urlImg = ref('')
const props = defineProps({
    theme: {
        type: String,
        required: true,
        default: ''
    },
})
const state = reactive({
	resolved: false,
	data: {} as UserInfo
});
async function getGraphData() {
    const response = await instance.acquireTokenSilent({
        ...loginRequest
    }).catch(async (e) => {
        if (e instanceof InteractionRequiredAuthError) {
            await instance.acquireTokenRedirect(loginRequest);
        }
        throw e;
    });
	if (inProgress.value === InteractionStatus.None) {
		const graphData = await callMsGraph(response.accessToken);
		state.data = graphData;
    const graphDataImg = await callMsGraphImg(response.accessToken);
    dataUrl(graphDataImg);
		state.resolved = true;
		stopWatcher();
	}
}
function  dataUrl(image:any){
  urlImg.value =URL.createObjectURL(image)
}
function getDark(event:any){
  if (localStorage) /* function to detect if localstorage is supported*/ {
      localStorage.setItem('selectedTheme', event)
  }
 
  emit('get-dark',event)
}

onMounted(() => {
	getGraphData();
  props.theme = `vsm_${props.theme}`
});
const stopWatcher = watch(inProgress, () => {
	if (!state.resolved) {
		getGraphData();
	}
});


const logoutRedirect = () => {
  instance.logoutRedirect();
}
</script>

<style>

</style>